Index: /trunk/include/VBox/err.h
===================================================================
--- /trunk/include/VBox/err.h	(revision 43393)
+++ /trunk/include/VBox/err.h	(revision 43394)
@@ -157,5 +157,5 @@
 /** Indicating that a rescheduling to vmx-mode execution.
  * Typically caused by REM detecting that hardware-accelerated raw-mode execution is possible. */
-#define VINF_EM_RESCHEDULE_HWACC            1116
+#define VINF_EM_RESCHEDULE_HM            1116
 /** Indicating that a rescheduling to raw-mode execution.
  * Typically caused by REM detecting that raw-mode execution is possible.
Index: /trunk/include/VBox/sup.h
===================================================================
--- /trunk/include/VBox/sup.h	(revision 43393)
+++ /trunk/include/VBox/sup.h	(revision 43394)
@@ -424,6 +424,6 @@
 /** @see VMMR0_DO_RAW_RUN. */
 #define SUP_VMMR0_DO_RAW_RUN    0
-/** @see VMMR0_DO_HWACC_RUN. */
-#define SUP_VMMR0_DO_HWACC_RUN  1
+/** @see VMMR0_DO_HM_RUN. */
+#define SUP_VMMR0_DO_HM_RUN  1
 /** @see VMMR0_DO_NOP */
 #define SUP_VMMR0_DO_NOP        2
Index: /trunk/include/VBox/vmm/dbgf.h
===================================================================
--- /trunk/include/VBox/vmm/dbgf.h	(revision 43393)
+++ /trunk/include/VBox/vmm/dbgf.h	(revision 43394)
@@ -202,5 +202,5 @@
     DBGFEVENTCTX_REM,
     /** VMX / AVT mode. */
-    DBGFEVENTCTX_HWACCL,
+    DBGFEVENTCTX_HM,
     /** Hypervisor context. */
     DBGFEVENTCTX_HYPER,
Index: /trunk/include/VBox/vmm/em.h
===================================================================
--- /trunk/include/VBox/vmm/em.h	(revision 43393)
+++ /trunk/include/VBox/vmm/em.h	(revision 43394)
@@ -52,5 +52,5 @@
     EMSTATE_RAW,
     /** Hardware accelerated raw-mode execution. */
-    EMSTATE_HWACC,
+    EMSTATE_HM,
     /** Value reserved for future use (used to be PARAV). */
     EMSTATE_RESERVED,
@@ -68,5 +68,5 @@
     EMSTATE_DEBUG_GUEST_RAW,
     /** Guest debug event from hardware accelerated mode is being processed. */
-    EMSTATE_DEBUG_GUEST_HWACC,
+    EMSTATE_DEBUG_GUEST_HM,
     /** Guest debug event from recompiled-mode is being processed. */
     EMSTATE_DEBUG_GUEST_REM,
Index: /trunk/include/VBox/vmm/iom.h
===================================================================
--- /trunk/include/VBox/vmm/iom.h	(revision 43393)
+++ /trunk/include/VBox/vmm/iom.h	(revision 43394)
@@ -76,5 +76,5 @@
                                  && (rc) >= VINF_EM_FIRST \
                                  && (rc) != VINF_EM_RESCHEDULE_RAW \
-                                 && (rc) != VINF_EM_RESCHEDULE_HWACC \
+                                 && (rc) != VINF_EM_RESCHEDULE_HM \
                                 ) \
                             )
Index: /trunk/include/VBox/vmm/vmm.h
===================================================================
--- /trunk/include/VBox/vmm/vmm.h	(revision 43393)
+++ /trunk/include/VBox/vmm/vmm.h	(revision 43394)
@@ -321,5 +321,5 @@
     VMMR0_DO_RAW_RUN = SUP_VMMR0_DO_RAW_RUN,
     /** Run guest code using the available hardware acceleration technology. */
-    VMMR0_DO_HWACC_RUN = SUP_VMMR0_DO_HWACC_RUN,
+    VMMR0_DO_HM_RUN = SUP_VMMR0_DO_HM_RUN,
     /** Official NOP that we use for profiling. */
     VMMR0_DO_NOP = SUP_VMMR0_DO_NOP,
@@ -353,7 +353,7 @@
     VMMR0_DO_VMMR0_TERM,
     /** Setup the hardware accelerated raw-mode session. */
-    VMMR0_DO_HWACC_SETUP_VM,
+    VMMR0_DO_HM_SETUP_VM,
     /** Attempt to enable or disable hardware accelerated raw-mode. */
-    VMMR0_DO_HWACC_ENABLE,
+    VMMR0_DO_HM_ENABLE,
     /** Calls function in the hypervisor.
      * The caller must setup the hypervisor context so the call will be performed.
Index: /trunk/src/VBox/Debugger/DBGConsole.cpp
===================================================================
--- /trunk/src/VBox/Debugger/DBGConsole.cpp	(revision 43393)
+++ /trunk/src/VBox/Debugger/DBGConsole.cpp	(revision 43394)
@@ -580,5 +580,5 @@
         case DBGFEVENTCTX_RAW:      return "raw";
         case DBGFEVENTCTX_REM:      return "rem";
-        case DBGFEVENTCTX_HWACCL:   return "hwaccl";
+        case DBGFEVENTCTX_HM:   return "hwaccl";
         case DBGFEVENTCTX_HYPER:    return "hyper";
         case DBGFEVENTCTX_OTHER:    return "other";
Index: /trunk/src/VBox/HostDrivers/Support/SUPDrv.c
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDrv.c	(revision 43394)
@@ -1029,6 +1029,6 @@
                 pDevExt->pfnVMMR0EntryFast(pSession->pVM, idCpu, SUP_VMMR0_DO_RAW_RUN);
                 break;
-            case SUP_IOCTL_FAST_DO_HWACC_RUN:
-                pDevExt->pfnVMMR0EntryFast(pSession->pVM, idCpu, SUP_VMMR0_DO_HWACC_RUN);
+            case SUP_IOCTL_FAST_DO_HM_RUN:
+                pDevExt->pfnVMMR0EntryFast(pSession->pVM, idCpu, SUP_VMMR0_DO_HM_RUN);
                 break;
             case SUP_IOCTL_FAST_DO_NOP:
Index: /trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/SUPDrvIOC.h	(revision 43394)
@@ -101,6 +101,6 @@
 /** Fast path IOCtl: VMMR0_DO_RAW_RUN */
 #define SUP_IOCTL_FAST_DO_RAW_RUN               SUP_CTL_CODE_FAST(64)
-/** Fast path IOCtl: VMMR0_DO_HWACC_RUN */
-#define SUP_IOCTL_FAST_DO_HWACC_RUN             SUP_CTL_CODE_FAST(65)
+/** Fast path IOCtl: VMMR0_DO_HM_RUN */
+#define SUP_IOCTL_FAST_DO_HM_RUN             SUP_CTL_CODE_FAST(65)
 /** Just a NOP call for profiling the latency of a fast ioctl call to VMMR0. */
 #define SUP_IOCTL_FAST_DO_NOP                   SUP_CTL_CODE_FAST(66)
Index: /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/SUPLib.cpp	(revision 43394)
@@ -591,6 +591,6 @@
     if (RT_LIKELY(uOperation == SUP_VMMR0_DO_RAW_RUN))
         return suplibOsIOCtlFast(&g_supLibData, SUP_IOCTL_FAST_DO_RAW_RUN, idCpu);
-    if (RT_LIKELY(uOperation == SUP_VMMR0_DO_HWACC_RUN))
-        return suplibOsIOCtlFast(&g_supLibData, SUP_IOCTL_FAST_DO_HWACC_RUN, idCpu);
+    if (RT_LIKELY(uOperation == SUP_VMMR0_DO_HM_RUN))
+        return suplibOsIOCtlFast(&g_supLibData, SUP_IOCTL_FAST_DO_HM_RUN, idCpu);
     if (RT_LIKELY(uOperation == SUP_VMMR0_DO_NOP))
         return suplibOsIOCtlFast(&g_supLibData, SUP_IOCTL_FAST_DO_NOP, idCpu);
@@ -607,5 +607,5 @@
      */
     AssertMsgReturn(    uOperation != SUP_VMMR0_DO_RAW_RUN
-                    &&  uOperation != SUP_VMMR0_DO_HWACC_RUN
+                    &&  uOperation != SUP_VMMR0_DO_HM_RUN
                     &&  uOperation != SUP_VMMR0_DO_NOP,
                     ("%#x\n", uOperation),
@@ -694,5 +694,5 @@
      */
     AssertMsgReturn(    uOperation != SUP_VMMR0_DO_RAW_RUN
-                    &&  uOperation != SUP_VMMR0_DO_HWACC_RUN
+                    &&  uOperation != SUP_VMMR0_DO_HM_RUN
                     &&  uOperation != SUP_VMMR0_DO_NOP,
                     ("%#x\n", uOperation),
Index: /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/darwin/SUPDrv-darwin.cpp	(revision 43394)
@@ -515,5 +515,5 @@
      */
     if (    iCmd == SUP_IOCTL_FAST_DO_RAW_RUN
-        ||  iCmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+        ||  iCmd == SUP_IOCTL_FAST_DO_HM_RUN
         ||  iCmd == SUP_IOCTL_FAST_DO_NOP)
         return supdrvIOCtlFast(iCmd, *(uint32_t *)pData, &g_DevExt, pSession);
Index: /trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/freebsd/SUPDrv-freebsd.c	(revision 43394)
@@ -289,5 +289,5 @@
      */
     if (    ulCmd == SUP_IOCTL_FAST_DO_RAW_RUN
-        ||  ulCmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+        ||  ulCmd == SUP_IOCTL_FAST_DO_HM_RUN
         ||  ulCmd == SUP_IOCTL_FAST_DO_NOP)
         return supdrvIOCtlFast(ulCmd, *(uint32_t *)pvData, &g_VBoxDrvFreeBSDDevExt, pSession);
Index: /trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/linux/SUPDrv-linux.c	(revision 43394)
@@ -540,5 +540,5 @@
 #ifdef HAVE_UNLOCKED_IOCTL
     if (RT_LIKELY(   uCmd == SUP_IOCTL_FAST_DO_RAW_RUN
-                  || uCmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+                  || uCmd == SUP_IOCTL_FAST_DO_HM_RUN
                   || uCmd == SUP_IOCTL_FAST_DO_NOP))
         return supdrvIOCtlFast(uCmd, ulArg, &g_DevExt, (PSUPDRVSESSION)pFilp->private_data);
@@ -550,5 +550,5 @@
     unlock_kernel();
     if (RT_LIKELY(   uCmd == SUP_IOCTL_FAST_DO_RAW_RUN
-                  || uCmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+                  || uCmd == SUP_IOCTL_FAST_DO_HM_RUN
                   || uCmd == SUP_IOCTL_FAST_DO_NOP))
         rc = supdrvIOCtlFast(uCmd, ulArg, &g_DevExt, (PSUPDRVSESSION)pFilp->private_data);
Index: /trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/solaris/SUPDrv-solaris.c	(revision 43394)
@@ -685,5 +685,5 @@
      */
     if (    Cmd == SUP_IOCTL_FAST_DO_RAW_RUN
-        ||  Cmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+        ||  Cmd == SUP_IOCTL_FAST_DO_HM_RUN
         ||  Cmd == SUP_IOCTL_FAST_DO_NOP)
     {
Index: /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 43393)
+++ /trunk/src/VBox/HostDrivers/Support/win/SUPDrv-win.cpp	(revision 43394)
@@ -356,5 +356,5 @@
     ULONG ulCmd = pStack->Parameters.DeviceIoControl.IoControlCode;
     if (    ulCmd == SUP_IOCTL_FAST_DO_RAW_RUN
-        ||  ulCmd == SUP_IOCTL_FAST_DO_HWACC_RUN
+        ||  ulCmd == SUP_IOCTL_FAST_DO_HM_RUN
         ||  ulCmd == SUP_IOCTL_FAST_DO_NOP)
     {
Index: /trunk/src/VBox/VMM/VMMR0/VMMR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/VMMR0.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR0/VMMR0.cpp	(revision 43394)
@@ -744,5 +744,5 @@
          * we hope to get away with page faults and later calling into the kernel.
          */
-        case VMMR0_DO_HWACC_RUN:
+        case VMMR0_DO_HM_RUN:
         {
 #ifdef VBOX_WITH_VMMR0_DISABLE_PREEMPTION
@@ -964,5 +964,5 @@
          * Attempt to enable hm mode and check the current setting.
          */
-        case VMMR0_DO_HWACC_ENABLE:
+        case VMMR0_DO_HM_ENABLE:
             return HMR0EnableAllCpus(pVM);
 
@@ -970,5 +970,5 @@
          * Setup the hardware accelerated session.
          */
-        case VMMR0_DO_HWACC_SETUP_VM:
+        case VMMR0_DO_HM_SETUP_VM:
             return HMR0SetupVM(pVM);
 
Index: /trunk/src/VBox/VMM/VMMR3/EM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/EM.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/EM.cpp	(revision 43394)
@@ -635,5 +635,5 @@
      */
     return    pVCpu->em.s.enmState == EMSTATE_RAW
-           || pVCpu->em.s.enmState == EMSTATE_HWACC
+           || pVCpu->em.s.enmState == EMSTATE_HM
            || pVCpu->em.s.enmState == EMSTATE_REM
          ? VINF_EM_RESCHEDULE
@@ -696,5 +696,5 @@
         case EMSTATE_NONE:              return "EMSTATE_NONE";
         case EMSTATE_RAW:               return "EMSTATE_RAW";
-        case EMSTATE_HWACC:             return "EMSTATE_HWACC";
+        case EMSTATE_HM:             return "EMSTATE_HM";
         case EMSTATE_REM:               return "EMSTATE_REM";
         case EMSTATE_HALTED:            return "EMSTATE_HALTED";
@@ -1197,5 +1197,5 @@
         if (   EMIsHwVirtExecutionEnabled(pVM)
             && HMR3CanExecuteGuest(pVM, pCtx))
-            return EMSTATE_HWACC;
+            return EMSTATE_HM;
 
         /*
@@ -1686,5 +1686,5 @@
         if (    !VM_FF_ISPENDING(pVM, VM_FF_PGM_NO_MEMORY)
             &&  !VMCPU_FF_ISPENDING(pVCpu, VMCPU_FF_INHIBIT_INTERRUPTS)
-            &&  (!rc || rc >= VINF_EM_RESCHEDULE_HWACC)
+            &&  (!rc || rc >= VINF_EM_RESCHEDULE_HM)
             &&  !TRPMHasTrap(pVCpu) /* an interrupt could already be scheduled for dispatching in the recompiler. */
             &&  PATMAreInterruptsEnabled(pVM)
@@ -1931,5 +1931,5 @@
                 VBOXVMM_EM_FF_ALL_RET(pVCpu, rc);
                 if (   (   rc == VINF_EM_RESCHEDULE_REM
-                        || rc == VINF_EM_RESCHEDULE_HWACC)
+                        || rc == VINF_EM_RESCHEDULE_HM)
                     && pVCpu->em.s.fForceRAW)
                     rc = VINF_EM_RESCHEDULE_RAW;
@@ -1962,8 +1962,8 @@
                  * Reschedule - to hardware accelerated raw-mode execution.
                  */
-                case VINF_EM_RESCHEDULE_HWACC:
-                    Log2(("EMR3ExecuteVM: VINF_EM_RESCHEDULE_HWACC: %d -> %d (EMSTATE_HWACC)\n", enmOldState, EMSTATE_HWACC));
+                case VINF_EM_RESCHEDULE_HM:
+                    Log2(("EMR3ExecuteVM: VINF_EM_RESCHEDULE_HM: %d -> %d (EMSTATE_HM)\n", enmOldState, EMSTATE_HM));
                     Assert(!pVCpu->em.s.fForceRAW);
-                    pVCpu->em.s.enmState = EMSTATE_HWACC;
+                    pVCpu->em.s.enmState = EMSTATE_HM;
                     break;
 
@@ -2163,8 +2163,8 @@
                     && (pVCpu->em.s.MWait.fWait & EMMWAIT_FLAG_ACTIVE)
                     && (   enmNewState == EMSTATE_RAW
-                        || enmNewState == EMSTATE_HWACC
+                        || enmNewState == EMSTATE_HM
                         || enmNewState == EMSTATE_REM
                         || enmNewState == EMSTATE_DEBUG_GUEST_RAW
-                        || enmNewState == EMSTATE_DEBUG_GUEST_HWACC
+                        || enmNewState == EMSTATE_DEBUG_GUEST_HM
                         || enmNewState == EMSTATE_DEBUG_GUEST_REM) )
                 {
@@ -2196,5 +2196,5 @@
                  * Execute hardware accelerated raw.
                  */
-                case EMSTATE_HWACC:
+                case EMSTATE_HM:
 #ifndef IEM_VERIFICATION_MODE /* remove later */
                     rc = emR3HmExecute(pVM, pVCpu, &fFFDone);
Index: /trunk/src/VBox/VMM/VMMR3/EMHM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/EMHM.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/EMHM.cpp	(revision 43394)
@@ -81,5 +81,5 @@
 static int emR3HmStep(PVM pVM, PVMCPU pVCpu)
 {
-    Assert(pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HWACC);
+    Assert(pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HM);
 
     int         rc;
@@ -132,5 +132,5 @@
     int     rc          = VINF_SUCCESS;
     EMSTATE enmOldState = pVCpu->em.s.enmState;
-    pVCpu->em.s.enmState  = EMSTATE_DEBUG_GUEST_HWACC;
+    pVCpu->em.s.enmState  = EMSTATE_DEBUG_GUEST_HM;
 
     Log(("Single step BEGIN:\n"));
@@ -217,5 +217,5 @@
             {
 #ifdef EM_NOTIFY_HM
-                if (pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HWACC)
+                if (pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HM)
                     HMR3NotifyEmulated(pVCpu);
 #endif
@@ -247,5 +247,5 @@
 
 #ifdef EM_NOTIFY_HM
-    if (pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HWACC)
+    if (pVCpu->em.s.enmState == EMSTATE_DEBUG_GUEST_HM)
         HMR3NotifyEmulated(pVCpu);
 #endif
@@ -584,5 +584,5 @@
             VBOXVMM_EM_FF_ALL_RET(pVCpu, rc);
             if (    rc != VINF_SUCCESS
-                &&  rc != VINF_EM_RESCHEDULE_HWACC)
+                &&  rc != VINF_EM_RESCHEDULE_HM)
             {
                 *pfFFDone = true;
Index: /trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 43394)
@@ -774,8 +774,8 @@
 
     /* Enable VT-x or AMD-V on all host CPUs. */
-    rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HWACC_ENABLE, 0, NULL);
+    rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HM_ENABLE, 0, NULL);
     if (RT_FAILURE(rc))
     {
-        LogRel(("HMR3InitFinalize: SUPR3CallVMMR0Ex VMMR0_DO_HWACC_ENABLE failed with %Rrc\n", rc));
+        LogRel(("HMR3InitFinalize: SUPR3CallVMMR0Ex VMMR0_DO_HM_ENABLE failed with %Rrc\n", rc));
         return rc;
     }
@@ -1187,5 +1187,5 @@
             }
 
-            rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HWACC_SETUP_VM, 0, NULL);
+            rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HM_SETUP_VM, 0, NULL);
             AssertRC(rc);
             if (rc == VINF_SUCCESS)
@@ -1386,5 +1386,5 @@
                 pVM->hm.s.fNestedPaging = pVM->hm.s.fAllowNestedPaging;
 
-            rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HWACC_SETUP_VM, 0, NULL);
+            rc = SUPR3CallVMMR0Ex(pVM->pVMR0, 0 /*idCpu*/, VMMR0_DO_HM_SETUP_VM, 0, NULL);
             AssertRC(rc);
             if (rc == VINF_SUCCESS)
Index: /trunk/src/VBox/VMM/VMMR3/TRPM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/TRPM.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/TRPM.cpp	(revision 43394)
@@ -1529,5 +1529,5 @@
                 AssertRC(rc);
                 STAM_COUNTER_INC(&pVM->trpm.s.paStatForwardedIRQR3[u8Interrupt]);
-                return HMR3IsActive(pVCpu) ? VINF_EM_RESCHEDULE_HWACC : VINF_EM_RESCHEDULE_REM;
+                return HMR3IsActive(pVCpu) ? VINF_EM_RESCHEDULE_HM : VINF_EM_RESCHEDULE_REM;
             }
             /* If the guest gate is not patched, then we will check (again) if we can patch it. */
@@ -1564,5 +1564,5 @@
         {
             AssertRC(rc);
-            return HMR3IsActive(pVCpu) ? VINF_EM_RESCHEDULE_HWACC : VINF_EM_RESCHEDULE_REM; /* (Heed the halted state if this is changed!) */
+            return HMR3IsActive(pVCpu) ? VINF_EM_RESCHEDULE_HM : VINF_EM_RESCHEDULE_REM; /* (Heed the halted state if this is changed!) */
         }
 #else
@@ -1577,5 +1577,5 @@
                 AssertRC(rc);
                 STAM_COUNTER_INC(&pVM->trpm.s.paStatForwardedIRQR3[u8Interrupt]);
-                return VINF_EM_RESCHEDULE_HWACC;
+                return VINF_EM_RESCHEDULE_HM;
             }
         }
Index: /trunk/src/VBox/VMM/VMMR3/VMM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/VMM.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/VMM.cpp	(revision 43394)
@@ -1283,5 +1283,5 @@
             rc = VERR_GENERAL_FAILURE;
 #else
-            rc = SUPR3CallVMMR0Fast(pVM->pVMR0, VMMR0_DO_HWACC_RUN, pVCpu->idCpu);
+            rc = SUPR3CallVMMR0Fast(pVM->pVMR0, VMMR0_DO_HM_RUN, pVCpu->idCpu);
             if (RT_LIKELY(rc == VINF_SUCCESS))
                 rc = pVCpu->vmm.s.iLastGZRc;
Index: /trunk/src/VBox/VMM/VMMR3/VMMTests.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/VMMTests.cpp	(revision 43393)
+++ /trunk/src/VBox/VMM/VMMR3/VMMTests.cpp	(revision 43394)
@@ -559,5 +559,5 @@
 
             uint64_t TickThisStart = ASMReadTSC();
-            rc = SUPR3CallVMMR0Fast(pVM->pVMR0, VMMR0_DO_HWACC_RUN, 0);
+            rc = SUPR3CallVMMR0Fast(pVM->pVMR0, VMMR0_DO_HM_RUN, 0);
             uint64_t TickThisElapsed = ASMReadTSC() - TickThisStart;
             if (RT_FAILURE(rc))
Index: /trunk/src/VBox/VMM/include/EMHandleRCTmpl.h
===================================================================
--- /trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 43393)
+++ /trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 43394)
@@ -47,5 +47,5 @@
             break;
         case VINF_EM_RESCHEDULE_RAW:
-        case VINF_EM_RESCHEDULE_HWACC:
+        case VINF_EM_RESCHEDULE_HM:
         case VINF_EM_RAW_INTERRUPT:
         case VINF_EM_RAW_TO_R3:
Index: /trunk/src/recompiler/VBoxRecompiler.c
===================================================================
--- /trunk/src/recompiler/VBoxRecompiler.c	(revision 43393)
+++ /trunk/src/recompiler/VBoxRecompiler.c	(revision 43394)
@@ -865,5 +865,5 @@
                 break;
             case EXCP_EXECUTE_RAW:
-            case EXCP_EXECUTE_HWACC:
+            case EXCP_EXECUTE_HM:
                 /** @todo: is it correct? No! */
                 rc = VINF_SUCCESS;
@@ -954,8 +954,8 @@
 
     /* Make sure this flag is set; we might never execute remR3CanExecuteRaw in the AMD-V case.
-     * CPU_RAW_HWACC makes sure we never execute interrupt handlers in the recompiler.
+     * CPU_RAW_HM makes sure we never execute interrupt handlers in the recompiler.
      */
     if (HMIsEnabled(pVM))
-        pVM->rem.s.Env.state |= CPU_RAW_HWACC;
+        pVM->rem.s.Env.state |= CPU_RAW_HM;
 
     /* Skip the TB flush as that's rather expensive and not necessary for single instruction emulation. */
@@ -1053,7 +1053,7 @@
              * Switch to hardware accelerated RAW-mode.
              */
-            case EXCP_EXECUTE_HWACC:
-                Log2(("REMR3EmulateInstruction: cpu_exec -> EXCP_EXECUTE_HWACC\n"));
-                rc = VINF_EM_RESCHEDULE_HWACC;
+            case EXCP_EXECUTE_HM:
+                Log2(("REMR3EmulateInstruction: cpu_exec -> EXCP_EXECUTE_HM\n"));
+                rc = VINF_EM_RESCHEDULE_HM;
                 break;
 
@@ -1256,7 +1256,7 @@
              * Switch to hardware accelerated RAW-mode.
              */
-            case EXCP_EXECUTE_HWACC:
-                RTLogPrintf("remR3RunLoggingStep: cpu_exec -> EXCP_EXECUTE_HWACC rc=VINF_EM_RESCHEDULE_HWACC\n");
-                rc = VINF_EM_RESCHEDULE_HWACC;
+            case EXCP_EXECUTE_HM:
+                RTLogPrintf("remR3RunLoggingStep: cpu_exec -> EXCP_EXECUTE_HM rc=VINF_EM_RESCHEDULE_HM\n");
+                rc = VINF_EM_RESCHEDULE_HM;
                 break;
 
@@ -1377,7 +1377,7 @@
          * Switch to hardware accelerated RAW-mode.
          */
-        case EXCP_EXECUTE_HWACC:
-            Log2(("REMR3Run: cpu_exec -> EXCP_EXECUTE_HWACC\n"));
-            rc = VINF_EM_RESCHEDULE_HWACC;
+        case EXCP_EXECUTE_HM:
+            Log2(("REMR3Run: cpu_exec -> EXCP_EXECUTE_HM\n"));
+            rc = VINF_EM_RESCHEDULE_HM;
             break;
 
@@ -1440,5 +1440,5 @@
         CPUMCTX Ctx;
 
-        env->state |= CPU_RAW_HWACC;
+        env->state |= CPU_RAW_HM;
 
         /*
@@ -1530,5 +1530,5 @@
         if (HMR3CanExecuteGuest(env->pVM, &Ctx) == true)
         {
-            *piException = EXCP_EXECUTE_HWACC;
+            *piException = EXCP_EXECUTE_HM;
             return true;
         }
Index: /trunk/src/recompiler/cpu-defs.h
===================================================================
--- /trunk/src/recompiler/cpu-defs.h	(revision 43393)
+++ /trunk/src/recompiler/cpu-defs.h	(revision 43394)
@@ -77,5 +77,5 @@
 #ifdef VBOX
 # define EXCP_EXECUTE_RAW   0x11024 /**< execute raw mode. */
-# define EXCP_EXECUTE_HWACC 0x11025 /**< execute hardware accelerated raw mode. */
+# define EXCP_EXECUTE_HM 0x11025 /**< execute hardware accelerated raw mode. */
 # define EXCP_SINGLE_INSTR  0x11026 /**< executed single instruction. */
 # define EXCP_RC            0x11027 /**< a EM rc was raised (VMR3Reset/Suspend/PowerOff). */
Index: /trunk/src/recompiler/cpu-exec.c
===================================================================
--- /trunk/src/recompiler/cpu-exec.c	(revision 43393)
+++ /trunk/src/recompiler/cpu-exec.c	(revision 43394)
@@ -437,5 +437,5 @@
                                 || !(env->eflags & IF_MASK)
                                 ||  (env->hflags & HF_INHIBIT_IRQ_MASK)
-                                ||  (env->state & CPU_RAW_HWACC)
+                                ||  (env->state & CPU_RAW_HM)
                                )
                             {
Index: /trunk/src/recompiler/target-i386/cpu.h
===================================================================
--- /trunk/src/recompiler/target-i386/cpu.h	(revision 43393)
+++ /trunk/src/recompiler/target-i386/cpu.h	(revision 43394)
@@ -910,5 +910,5 @@
 # define CPU_EMULATE_SINGLE_INSTR 0x0040 /* Execute a single instruction in emulation mode */
 # define CPU_EMULATE_SINGLE_STEP  0x0080 /* go into single step mode */
-# define CPU_RAW_HWACC            0x0100 /* Set after first time HWACC is executed, never cleared. */
+# define CPU_RAW_HM            0x0100 /* Set after first time HWACC is executed, never cleared. */
 /** @} */
 #endif /* !VBOX */