Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 43459)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.cpp	(revision 43460)
@@ -1633,5 +1633,5 @@
     /* Start/Show action is deremined by 1st item: */
     if (pItem && pItem->accessible())
-        m_pAction_Common_StartOrShow->setState(isItemPoweredOff(pItem) ? 1 : 2);
+        m_pAction_Common_StartOrShow->setState(UIVMItem::isItemPoweredOff(pItem) ? 1 : 2);
     else
         m_pAction_Common_StartOrShow->setState(1);
@@ -1640,9 +1640,9 @@
     UIVMItem *pFirstStartedAction = 0;
     foreach (UIVMItem *pSelectedItem, items)
-        if (isItemStarted(pSelectedItem))
+        if (UIVMItem::isItemStarted(pSelectedItem))
             pFirstStartedAction = pSelectedItem;
     /* Update the Pause/Resume action appearance: */
     m_pAction_Common_PauseAndResume->blockSignals(true);
-    m_pAction_Common_PauseAndResume->setChecked(pFirstStartedAction && isItemPaused(pFirstStartedAction));
+    m_pAction_Common_PauseAndResume->setChecked(pFirstStartedAction && UIVMItem::isItemPaused(pFirstStartedAction));
     m_pAction_Common_PauseAndResume->updateAppearance();
     m_pAction_Common_PauseAndResume->blockSignals(false);
@@ -1685,5 +1685,5 @@
                    items.size() == 1 &&
                    pItem->accessible() &&
-                   !isItemStuck(pItem);
+                   !UIVMItem::isItemStuck(pItem);
         }
         case UIActionIndexSelector_Simple_Machine_Clone:
@@ -1691,5 +1691,5 @@
             return !m_pChooser->isGroupSavingInProgress() &&
                    items.size() == 1 &&
-                   isItemEditable(pItem);
+                   UIVMItem::isItemEditable(pItem);
         }
         case UIActionIndexSelector_Simple_Machine_Remove:
@@ -1775,5 +1775,5 @@
 {
     foreach (UIVMItem *pItem, items)
-        if (!isItemPoweredOff(pItem))
+        if (!UIVMItem::isItemPoweredOff(pItem))
             return false;
     return true;
@@ -1785,5 +1785,5 @@
     foreach (UIVMItem *pItem, items)
     {
-        if (!isItemRunning(pItem))
+        if (!UIVMItem::isItemRunning(pItem))
             continue;
 
@@ -1844,5 +1844,5 @@
 {
     foreach (UIVMItem *pItem, items)
-        if (!pItem->accessible() || isItemEditable(pItem))
+        if (!pItem->accessible() || UIVMItem::isItemEditable(pItem))
             return true;
     return false;
@@ -1854,6 +1854,6 @@
     foreach (UIVMItem *pItem, items)
     {
-        if ((isItemPoweredOff(pItem) && isItemEditable(pItem)) ||
-            (isItemStarted(pItem) && pItem->canSwitchTo()))
+        if ((UIVMItem::isItemPoweredOff(pItem) && UIVMItem::isItemEditable(pItem)) ||
+            (UIVMItem::isItemStarted(pItem) && pItem->canSwitchTo()))
             return true;
     }
@@ -1865,5 +1865,5 @@
 {
     foreach (UIVMItem *pItem, items)
-        if (isItemSaved(pItem) && isItemEditable(pItem))
+        if (UIVMItem::isItemSaved(pItem) && UIVMItem::isItemEditable(pItem))
             return true;
     return false;
@@ -1874,5 +1874,5 @@
 {
     foreach (UIVMItem *pItem, items)
-        if (isItemStarted(pItem))
+        if (UIVMItem::isItemStarted(pItem))
             return true;
     return false;
@@ -1883,72 +1883,7 @@
 {
     foreach (UIVMItem *pItem, items)
-        if (isItemRunning(pItem))
+        if (UIVMItem::isItemRunning(pItem))
             return true;
     return false;
 }
 
-/* static */
-bool UISelectorWindow::isItemEditable(UIVMItem *pItem)
-{
-    return pItem->accessible() &&
-           pItem->sessionState() == KSessionState_Unlocked;
-}
-
-/* static */
-bool UISelectorWindow::isItemSaved(UIVMItem *pItem)
-{
-    if (pItem->accessible() &&
-        pItem->machineState() == KMachineState_Saved)
-        return true;
-    return false;
-}
-
-/* static */
-bool UISelectorWindow::isItemPoweredOff(UIVMItem *pItem)
-{
-    if (pItem->accessible() &&
-        (pItem->machineState() == KMachineState_PoweredOff ||
-         pItem->machineState() == KMachineState_Saved ||
-         pItem->machineState() == KMachineState_Teleported ||
-         pItem->machineState() == KMachineState_Aborted))
-        return true;
-    return false;
-}
-
-/* static */
-bool UISelectorWindow::isItemStarted(UIVMItem *pItem)
-{
-    return isItemRunning(pItem) || isItemPaused(pItem);
-}
-
-/* static */
-bool UISelectorWindow::isItemRunning(UIVMItem *pItem)
-{
-    if (pItem->accessible() &&
-        (pItem->machineState() == KMachineState_Running ||
-         pItem->machineState() == KMachineState_Teleporting ||
-         pItem->machineState() == KMachineState_LiveSnapshotting))
-        return true;
-    return false;
-}
-
-/* static */
-bool UISelectorWindow::isItemPaused(UIVMItem *pItem)
-{
-    if (pItem->accessible() &&
-        (pItem->machineState() == KMachineState_Paused ||
-         pItem->machineState() == KMachineState_TeleportingPausedVM))
-        return true;
-    return false;
-
-}
-
-/* static */
-bool UISelectorWindow::isItemStuck(UIVMItem *pItem)
-{
-    if (pItem->accessible() &&
-        pItem->machineState() == KMachineState_Stuck)
-        return true;
-    return false;
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 43459)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UISelectorWindow.h	(revision 43460)
@@ -158,11 +158,4 @@
     static bool isAtLeastOneItemStarted(const QList<UIVMItem*> &items);
     static bool isAtLeastOneItemRunning(const QList<UIVMItem*> &items);
-    static bool isItemEditable(UIVMItem *pItem);
-    static bool isItemSaved(UIVMItem *pItem);
-    static bool isItemPoweredOff(UIVMItem *pItem);
-    static bool isItemStarted(UIVMItem *pItem);
-    static bool isItemRunning(UIVMItem *pItem);
-    static bool isItemPaused(UIVMItem *pItem);
-    static bool isItemStuck(UIVMItem *pItem);
 
     /* Central splitter window: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.cpp	(revision 43459)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.cpp	(revision 43460)
@@ -415,4 +415,69 @@
 }
 
+/* static */
+bool UIVMItem::isItemEditable(UIVMItem *pItem)
+{
+    return pItem->accessible() &&
+           pItem->sessionState() == KSessionState_Unlocked;
+}
+
+/* static */
+bool UIVMItem::isItemSaved(UIVMItem *pItem)
+{
+    if (pItem->accessible() &&
+        pItem->machineState() == KMachineState_Saved)
+        return true;
+    return false;
+}
+
+/* static */
+bool UIVMItem::isItemPoweredOff(UIVMItem *pItem)
+{
+    if (pItem->accessible() &&
+        (pItem->machineState() == KMachineState_PoweredOff ||
+         pItem->machineState() == KMachineState_Saved ||
+         pItem->machineState() == KMachineState_Teleported ||
+         pItem->machineState() == KMachineState_Aborted))
+        return true;
+    return false;
+}
+
+/* static */
+bool UIVMItem::isItemStarted(UIVMItem *pItem)
+{
+    return isItemRunning(pItem) || isItemPaused(pItem);
+}
+
+/* static */
+bool UIVMItem::isItemRunning(UIVMItem *pItem)
+{
+    if (pItem->accessible() &&
+        (pItem->machineState() == KMachineState_Running ||
+         pItem->machineState() == KMachineState_Teleporting ||
+         pItem->machineState() == KMachineState_LiveSnapshotting))
+        return true;
+    return false;
+}
+
+/* static */
+bool UIVMItem::isItemPaused(UIVMItem *pItem)
+{
+    if (pItem->accessible() &&
+        (pItem->machineState() == KMachineState_Paused ||
+         pItem->machineState() == KMachineState_TeleportingPausedVM))
+        return true;
+    return false;
+
+}
+
+/* static */
+bool UIVMItem::isItemStuck(UIVMItem *pItem)
+{
+    if (pItem->accessible() &&
+        pItem->machineState() == KMachineState_Stuck)
+        return true;
+    return false;
+}
+
 QString UIVMItemMimeData::m_type = "application/org.virtualbox.gui.vmselector.uivmitem";
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.h	(revision 43459)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/UIVMItem.h	(revision 43460)
@@ -65,4 +65,12 @@
     bool switchTo();
 
+    static bool isItemEditable(UIVMItem *pItem);
+    static bool isItemSaved(UIVMItem *pItem);
+    static bool isItemPoweredOff(UIVMItem *pItem);
+    static bool isItemStarted(UIVMItem *pItem);
+    static bool isItemRunning(UIVMItem *pItem);
+    static bool isItemPaused(UIVMItem *pItem);
+    static bool isItemStuck(UIVMItem *pItem);
+
 private:
 