Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 43477)
@@ -5148,17 +5148,17 @@
     <message>
         <source>IDE Controller</source>
-        <translation>IDE контроллер</translation>
+        <translation type="obsolete">IDE контроллер</translation>
     </message>
     <message>
         <source>SATA Controller</source>
-        <translation>SATA контроллер</translation>
+        <translation type="obsolete">SATA контроллер</translation>
     </message>
     <message>
         <source>SCSI Controller</source>
-        <translation>SCSI контроллер</translation>
+        <translation type="obsolete">SCSI контроллер</translation>
     </message>
     <message>
         <source>Floppy Controller</source>
-        <translation>Floppy контроллер</translation>
+        <translation type="obsolete">Floppy контроллер</translation>
     </message>
     <message>
@@ -5280,5 +5280,5 @@
     <message>
         <source>SAS Controller</source>
-        <translation>SAS контроллер</translation>
+        <translation type="obsolete">SAS контроллер</translation>
     </message>
     <message>
@@ -5407,4 +5407,13 @@
         <source>Selects the port count of the SATA storage controller currently selected in the Storage Tree. This must be at least one more than the highest port number you need to use.</source>
         <translation>Задаёт количество портов контроллера носителей информации типа SATA, выбранного в данный момент в дереве носителей информации. Это значение не может быть меньше, чем максимальный номер использованного порта + 1.</translation>
+    </message>
+    <message>
+        <source>%1: %2</source>
+        <comment>controller name wrapper</comment>
+        <translation>%1: %2</translation>
+    </message>
+    <message>
+        <source>Controller</source>
+        <translation>Контроллер</translation>
     </message>
 </context>
@@ -9249,21 +9258,21 @@
     <message>
         <source>IDE Controller</source>
-        <translation>IDE контроллер</translation>
+        <translation type="obsolete">IDE контроллер</translation>
     </message>
     <message>
         <source>SATA Controller</source>
-        <translation>SATA контроллер</translation>
+        <translation type="obsolete">SATA контроллер</translation>
     </message>
     <message>
         <source>SCSI Controller</source>
-        <translation>SCSI контроллер</translation>
+        <translation type="obsolete">SCSI контроллер</translation>
     </message>
     <message>
         <source>Floppy Controller</source>
-        <translation>Floppy контроллер</translation>
+        <translation type="obsolete">Floppy контроллер</translation>
     </message>
     <message>
         <source>SAS Controller</source>
-        <translation>SAS контроллер</translation>
+        <translation type="obsolete">SAS контроллер</translation>
     </message>
     <message>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 43477)
@@ -544,5 +544,6 @@
             {
                 QString header = "<tr><td></td><td colspan=2><nobr>%1</nobr></td></tr>";
-                storageStat += header.arg (ctrName);
+                QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
+                storageStat += header.arg(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()));
                 int scsiIndex = 0;
                 foreach (const CMediumAttachment &attachment, attachments)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43477)
@@ -1453,5 +1453,6 @@
             const CStorageController &controller = controllers[i];
             /* Add controller information: */
-            item += QString(sSectionItemTpl3).arg(controller.GetName());
+            QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
+            item += QString(sSectionItemTpl3).arg(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()));
             ++ rows;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp	(revision 43477)
@@ -439,5 +439,6 @@
             {
                 /* Add controller information: */
-                m_text << UITextTableLine(controller.GetName(), QString());
+                QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
+                m_text << UITextTableLine(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()), QString());
                 fSomeInfo = true;
                 /* Populate map (its sorted!): */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 43477)
@@ -541,5 +541,6 @@
 QString ControllerItem::text() const
 {
-    return ctrName();
+    QString strControllerNameWrapper = UIMachineSettingsStorage::tr("%1: %2", "controller name wrapper");
+    return strControllerNameWrapper.arg(UIMachineSettingsStorage::tr("Controller"), ctrName());
 }
 
@@ -2307,25 +2308,25 @@
 void UIMachineSettingsStorage::addIDEController()
 {
-    addControllerWrapper (generateUniqueName (tr ("IDE Controller")), KStorageBus_IDE, KStorageControllerType_PIIX4);
+    addControllerWrapper (generateUniqueName ("IDE"), KStorageBus_IDE, KStorageControllerType_PIIX4);
 }
 
 void UIMachineSettingsStorage::addSATAController()
 {
-    addControllerWrapper (generateUniqueName (tr ("SATA Controller")), KStorageBus_SATA, KStorageControllerType_IntelAhci);
+    addControllerWrapper (generateUniqueName ("SATA"), KStorageBus_SATA, KStorageControllerType_IntelAhci);
 }
 
 void UIMachineSettingsStorage::addSCSIController()
 {
-    addControllerWrapper (generateUniqueName (tr ("SCSI Controller")), KStorageBus_SCSI, KStorageControllerType_LsiLogic);
+    addControllerWrapper (generateUniqueName ("SCSI"), KStorageBus_SCSI, KStorageControllerType_LsiLogic);
 }
 
 void UIMachineSettingsStorage::addFloppyController()
 {
-    addControllerWrapper (generateUniqueName (tr ("Floppy Controller")), KStorageBus_Floppy, KStorageControllerType_I82078);
+    addControllerWrapper (generateUniqueName ("Floppy"), KStorageBus_Floppy, KStorageControllerType_I82078);
 }
 
 void UIMachineSettingsStorage::addSASController()
 {
-    addControllerWrapper (generateUniqueName (tr ("SAS Controller")), KStorageBus_SAS, KStorageControllerType_LsiLogicSas);
+    addControllerWrapper (generateUniqueName ("SAS"), KStorageBus_SAS, KStorageControllerType_LsiLogicSas);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 43476)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 43477)
@@ -304,5 +304,5 @@
         case KStorageBus_IDE:
         {
-            strControllerName = tr("IDE Controller");
+            strControllerName = "IDE";
             ++m_iIDECount;
             if (m_iIDECount > 1)
@@ -312,5 +312,5 @@
         case KStorageBus_SATA:
         {
-            strControllerName = tr("SATA Controller");
+            strControllerName = "SATA";
             ++m_iSATACount;
             if (m_iSATACount > 1)
@@ -320,5 +320,5 @@
         case KStorageBus_SCSI:
         {
-            strControllerName = tr("SCSI Controller");
+            strControllerName = "SCSI";
             ++m_iSCSICount;
             if (m_iSCSICount > 1)
@@ -328,5 +328,5 @@
         case KStorageBus_Floppy:
         {
-            strControllerName = tr("Floppy Controller");
+            strControllerName = "Floppy";
             ++m_iFloppyCount;
             if (m_iFloppyCount > 1)
@@ -336,5 +336,5 @@
         case KStorageBus_SAS:
         {
-            strControllerName = tr("SAS Controller");
+            strControllerName = "SAS";
             ++m_iSASCount;
             if (m_iSASCount > 1)