Index: /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 43483)
+++ /trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 43484)
@@ -5409,11 +5409,6 @@
     </message>
     <message>
-        <source>%1: %2</source>
-        <comment>controller name wrapper</comment>
-        <translation>%1: %2</translation>
-    </message>
-    <message>
-        <source>Controller</source>
-        <translation>Контроллер</translation>
+        <source>Controller: %1</source>
+        <translation>Контроллер: %1</translation>
     </message>
 </context>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 43483)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMInformationDlg.cpp	(revision 43484)
@@ -544,6 +544,6 @@
             {
                 QString header = "<tr><td></td><td colspan=2><nobr>%1</nobr></td></tr>";
-                QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
-                storageStat += header.arg(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()));
+                QString strControllerName = QApplication::translate("UIMachineSettingsStorage", "Controller: %1");
+                storageStat += header.arg(strControllerName.arg(controller.GetName()));
                 int scsiIndex = 0;
                 foreach (const CMediumAttachment &attachment, attachments)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43483)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 43484)
@@ -1453,6 +1453,6 @@
             const CStorageController &controller = controllers[i];
             /* Add controller information: */
-            QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
-            item += QString(sSectionItemTpl3).arg(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()));
+            QString strControllerName = QApplication::translate("UIMachineSettingsStorage", "Controller: %1");
+            item += QString(sSectionItemTpl3).arg(strControllerName.arg(controller.GetName()));
             ++ rows;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp	(revision 43483)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/details/UIGDetailsElements.cpp	(revision 43484)
@@ -439,6 +439,6 @@
             {
                 /* Add controller information: */
-                QString strControllerNameWrapper = QApplication::translate("UIMachineSettingsStorage", "%1: %2", "controller name wrapper");
-                m_text << UITextTableLine(strControllerNameWrapper.arg(QApplication::translate("UIMachineSettingsStorage", "Controller"), controller.GetName()), QString());
+                QString strControllerName = QApplication::translate("UIMachineSettingsStorage", "Controller: %1");
+                m_text << UITextTableLine(strControllerName.arg(controller.GetName()), QString());
                 fSomeInfo = true;
                 /* Populate map (its sorted!): */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 43483)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 43484)
@@ -541,6 +541,5 @@
 QString ControllerItem::text() const
 {
-    QString strControllerNameWrapper = UIMachineSettingsStorage::tr("%1: %2", "controller name wrapper");
-    return strControllerNameWrapper.arg(UIMachineSettingsStorage::tr("Controller"), ctrName());
+    return UIMachineSettingsStorage::tr("Controller: %1").arg(ctrName());
 }
 