Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.cpp	(revision 43577)
@@ -153,4 +153,9 @@
     else
         emit sigHoverLeave();
+}
+
+void UIGChooserItem::updateGeometry()
+{
+    QIGraphicsWidget::updateGeometry();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.h	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItem.h	(revision 43577)
@@ -96,5 +96,5 @@
 
     /* API: Layout stuff: */
-    virtual void updateSizeHint() = 0;
+    void updateGeometry();
     virtual void updateLayout() = 0;
     virtual int minimumWidthHint() const = 0;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.cpp	(revision 43577)
@@ -732,15 +732,12 @@
 }
 
-void UIGChooserItemGroup::updateSizeHint()
-{
-    /* Update size-hints for all the items: */
+void UIGChooserItemGroup::updateLayout()
+{
+    /* Update size-hints for all the children: */
     foreach (UIGChooserItem *pItem, items())
-        pItem->updateSizeHint();
+        pItem->updateGeometry();
     /* Update size-hint for this item: */
     updateGeometry();
-}
-
-void UIGChooserItemGroup::updateLayout()
-{
+
     /* Prepare variables: */
     int iHorizontalMargin = data(GroupItemData_HorizonalMargin).toInt();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemGroup.h	(revision 43577)
@@ -150,5 +150,4 @@
 
     /* Helpers: Layout stuff: */
-    void updateSizeHint();
     void updateLayout();
     int minimumWidthHint(bool fClosedGroup) const;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.cpp	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.cpp	(revision 43577)
@@ -325,11 +325,9 @@
 }
 
-void UIGChooserItemMachine::updateSizeHint()
-{
+void UIGChooserItemMachine::updateLayout()
+{
+    /* Update size-hint for this item: */
     updateGeometry();
-}
-
-void UIGChooserItemMachine::updateLayout()
-{
+
     if (m_pToolBar)
     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.h	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserItemMachine.h	(revision 43577)
@@ -114,5 +114,4 @@
 
     /* Helpers: Layout stuff: */
-    void updateSizeHint();
     void updateLayout();
     int minimumWidthHint() const;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 43576)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 43577)
@@ -168,6 +168,4 @@
     int iViewportWidth = viewportSize.width() - 2 * iSceneMargin;
     int iViewportHeight = viewportSize.height() - 2 * iSceneMargin;
-    /* Update all the size-hints recursively: */
-    root()->updateSizeHint();
     /* Set root item position: */
     root()->setPos(iSceneMargin, iSceneMargin);
@@ -656,5 +654,5 @@
 {
     /* Update left root: */
-    m_pLeftRoot->updateSizeHint();
+    m_pLeftRoot->updateGeometry();
     m_pLeftRoot->updateLayout();
 }
@@ -663,5 +661,5 @@
 {
     /* Update right root: */
-    m_pRightRoot->updateSizeHint();
+    m_pRightRoot->updateGeometry();
     m_pRightRoot->updateLayout();
 }